#-*- coding:utf-8 -*-
#
#script_name u'PyTalkTimeCfg'
program_name = u'PyTTimeCfg'
Title_name  = u'PTTimeCfg'
Copyright = u'(c) 2010 masa'
version = u'1.00(0)'

"""
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.
"""

# Please change this part according to your environment
ini_file = "E:\\Data\\masa\\PyTalkTime.ini"
sound_path = "E:\\Sounds\\ttsound\\"
DingDong_file = "00.mp3"
VOL1 = 4 #for file except  '00.mp3'
VOL2 = 7 #for file '00.mp3'
Mark_Defp = VOL1
Mark_Mypt = 2
#VOL_List description: [[VOL1_mini,VOL2_mini],`,[VOL1_max,VOL2_max]]
VOL_List = [[0,0],[1,3],[2,5],[3,6],[4,7],[5,8],[6,8],[7,9],[8,10],[9,10],[10,10]]
#
Exist_ini_file = 0
#
import e32
import audio
import re
import os
import appuifw


def show_er_val():
    import sys
    type, value = sys.exc_info() [:2]
    #appuifw.note(unicode(str(type)+'\n'+str(value)), 'error')
    rtn = appuifw.query(unicode(str(type)+'\n'+str(value)), 'query')


def conf_read():
    global ini_file
    global VOL1
    global VOL2
    global Exist_ini_file

    if not os.path.exists(ini_file):
        Exist_ini_file = 0
        return
    # read ini file
    try :
        f = open(ini_file,'r')
        fData = f.read()
        f.close()
    except :
        Exist_ini_file = 0
        return

    Exist_ini_file = 1
    fData = unicode(fData)
    TalkTime_list = fData.split(u"\n")

    # search line of volume value
    for lnData in TalkTime_list:
        lnDatawk = re.sub(u"[ \t]+",u" ",lnData)
        Sdata = lnDatawk.split(u" ")

        if len(Sdata) < 2: continue # no Sdata[1] error
        if Sdata[0].upper() == u"VOLUME1":
            if int(Sdata[1]) <= 10: VOL1 = int(Sdata[1])
            else:                   VOL1 = 10
        if Sdata[0].upper() == u"VOLUME2":
            if int(Sdata[1]) <= 10: VOL2 = int(Sdata[1])
            else:                   VOL2 = 10


def conf_write(volume1, volume2):
    global ini_file
    global VOL1
    global VOL2

    if not os.path.exists(ini_file):
        conf_data = 'VOLUME1 ' + str(volume1) + '\n'
        conf_data = conf_data + 'VOLUME2 ' + str(volume2) + '\n'

        try:
            F = open(ini_file, 'w')
            try:
                F.write(conf_data)
            finally:
                F.close()
            eflg = 0
        except:
            show_er_val()
            eflg = 1
        return eflg

    FData = ''
    try:
        F = open(ini_file,'r')
        try:
            FData = F.read()
        finally:
            F.close()
    except:
        pass

    FData = unicode(FData)
    #split by \n and omit line that contain only (CR/LF)
    lnDatalist = [x for x in FData.split(u"\n") if len(x) > 1]

    conf_data = ''
    for lnData in lnDatalist:
        lnDatawk = (re.sub(u"[\n\r]+",u"",lnData)).strip()
        confData = lnDatawk.split(u" ", 1)
        if len(confData) < 1: continue # no confData error
        if confData[0].upper() == u"VOLUME1" or confData[0].upper() == u"VOLUME2":
            pass
        else:
            conf_data = conf_data + lnDatawk + u'\n'
    conf_data = conf_data + u'VOLUME1 ' + unicode(str(volume1)) + u'\n'
    conf_data = conf_data + u'VOLUME2 ' + unicode(str(volume2)) + u'\n'
    conf_data = conf_data.encode('utf-8')
    eflg = 1
    if conf_data:
        try:
            F = open(ini_file, 'w')
            try:
                F.write(conf_data)
            finally:
                F.close()
            eflg = 0
        except:
            show_er_val()
            eflg = 1
    return eflg


class Setvolume:
    def __init__(self):
        self.lock = e32.Ao_lock()
        self.max_vol = ''
        self.Menu_list = []
        self.Exit_flg = 0
        self.First_flg = 1
        self.cur_pointer = ''


    def do_exit(self):
        self.Exit_flg = 1
        self.lock.signal()


    def selected(self):
        global VOL1
        global VOL2
        global VOL_List
        global Exist_ini_file

        disp_Index = self.listbox.current()
        if self.cur_pointer != disp_Index or Exist_ini_file == 0:
            list_pointer = self.max_vol - disp_Index
            VOL1 = VOL_List[list_pointer][0]
            VOL2 = VOL_List[list_pointer][1]

            eflg = conf_write(VOL1, VOL2)
            if not eflg:
                appuifw.note(unicode('Conf data successfully stored'), 'info')
            else:
                appuifw.note(unicode('Some errors occurred'), 'error')
#        else:
#            appuifw.note(unicode('Conf data no need changes'), 'info')
        self.lock.signal()


    def main_proc(self):
        global VOL1
        global VOL2
        global VOL_List
        global Exist_ini_file

        old_title = appuifw.app.title

        Si = os.path.join(unicode(sound_path), unicode(DingDong_file))
        S = audio.Sound.open(Si)
        self.max_vol = S.max_volume()
        S.close()
        if self.max_vol > 10: self.max_vol = 10
        VOL_List = VOL_List[:(self.max_vol + 1)]

        while not self.Exit_flg:
            appuifw.app.title = Title_name + u' ' + version
            conf_read()

            self.Menu_list = []
            if Exist_ini_file:
                self.cur_pointer = self.max_vol - VOL1
            else:
                self.cur_pointer = self.max_vol - Mark_Mypt
            for x in range((self.max_vol + 1)):
                wk1 = self.max_vol - x
                if wk1 == VOL1 and Exist_ini_file:
                    wk2 = '[v] Vol' + str(wk1)
                    self.cur_pointer = x
                else:
                    wk2 = '[ ] Vol' + str(wk1)
                if wk1 == Mark_Defp or wk1 == Mark_Mypt:
                    wk2 = wk2 + ' *'
                self.Menu_list.append(unicode(wk2))

            if self.First_flg == 1:
                self.listbox = appuifw.Listbox(self.Menu_list, self.selected)
                appuifw.app.body = self.listbox
                appuifw.app.exit_key_handler = self.do_exit
                self.First_flg = 0
            self.listbox.set_list(self.Menu_list, self.cur_pointer)
            e32.ao_yield()
            self.lock.wait()

        appuifw.app.title = old_title


if __name__ == '__main__':
    Setvolume().main_proc()

#appuifw.app.set_exit()
#sys.exit()

